searchData={"items":[{"type":"task","doc":"Sobelow is a static analysis tool for discovering\nvulnerabilities in Phoenix applications.\n\nThis tool should be run in the root of the project directory\nwith the following command:\n\n    mix sobelow","title":"mix sobelow","ref":"Mix.Tasks.Sobelow.html"},{"type":"task","doc":"* `--root -r` - Specify application root directory\n* `--verbose -v` - Print vulnerable code snippets\n* `--ignore -i` - Ignore modules\n* `--ignore-files` - Ignore files\n* `--details -d` - Get module details\n* `--all-details` - Get all module details\n* `--private` - Skip update checks\n* `--strict` - Exit when bad syntax is encountered\n* `--mark-skip-all` - Mark all printed findings as skippable\n* `--clear-skip` - Clear configuration added by `--mark-skip-all`\n* `--skip` - Skip functions flagged with `#sobelow_skip` or tagged with `--mark-skip-all`\n* `--router` - Specify router location\n* `--exit` - Return non-zero exit status\n* `--threshold` - Only return findings at or above a given confidence level\n* `--format` - Specify findings output format\n* `--quiet` - Return no output if there are no findings\n* `--compact` - Minimal, single-line findings\n* `--save-config` - Generates a configuration file based on command line options\n* `--config` - Run Sobelow with configuration file\n* `--version` - Output current version of Sobelow","title":"Command line options - mix sobelow","ref":"Mix.Tasks.Sobelow.html#module-command-line-options"},{"type":"task","doc":"If specific modules, or classes of modules are not relevant\nto the scan, it is possible to ignore them with a\ncomma-separated list.\n\n    mix sobelow -i XSS.Raw,Traversal","title":"Ignoring modules - mix sobelow","ref":"Mix.Tasks.Sobelow.html#module-ignoring-modules"},{"type":"task","doc":"* XSS\n* XSS.Raw\n* XSS.SendResp\n* XSS.ContentType\n* XSS.HTML\n* SQL\n* SQL.Query\n* SQL.Stream\n* Config\n* Config.CSRF\n* Config.Headers\n* Config.CSP\n* Config.HTTPS\n* Config.HSTS\n* Config.Secrets\n* Config.CSWH\n* Vuln\n* Vuln.CookieRCE\n* Vuln.HeaderInject\n* Vuln.PlugNull\n* Vuln.Redirect\n* Vuln.Coherence\n* Vuln.Ecto\n* Traversal\n* Traversal.SendFile\n* Traversal.FileModule\n* Traversal.SendDownload\n* Misc\n* Misc.BinToTerm\n* Misc.FilePath\n* RCE.EEx\n* RCE.CodeModule\n* CI\n* CI.System\n* CI.OS\n* DOS\n* DOS.StringToAtom\n* DOS.ListToAtom\n* DOS.BinToAtom","title":"Supported modules - mix sobelow","ref":"Mix.Tasks.Sobelow.html#module-supported-modules"},{"type":"function","doc":"","title":"Mix.Tasks.Sobelow.main/1","ref":"Mix.Tasks.Sobelow.html#main/1"},{"type":"function","doc":"","title":"Mix.Tasks.Sobelow.run/1","ref":"Mix.Tasks.Sobelow.html#run/1"},{"type":"function","doc":"","title":"Mix.Tasks.Sobelow.run_diff/1","ref":"Mix.Tasks.Sobelow.html#run_diff/1"},{"type":"function","doc":"","title":"Mix.Tasks.Sobelow.set_env/2","ref":"Mix.Tasks.Sobelow.html#set_env/2"},{"type":"module","doc":"Sobelow is a static analysis tool for discovering\nvulnerabilities in Phoenix applications.","title":"Sobelow","ref":"Sobelow.html"},{"type":"function","doc":"","title":"Sobelow.all_details/0","ref":"Sobelow.html#all_details/0"},{"type":"function","doc":"","title":"Sobelow.details/0","ref":"Sobelow.html#details/0"},{"type":"function","doc":"","title":"Sobelow.finding_modules/0","ref":"Sobelow.html#finding_modules/0"},{"type":"function","doc":"","title":"Sobelow.format/0","ref":"Sobelow.html#format/0"},{"type":"function","doc":"","title":"Sobelow.get_env/1","ref":"Sobelow.html#get_env/1"},{"type":"function","doc":"","title":"Sobelow.get_ignored/0","ref":"Sobelow.html#get_ignored/0"},{"type":"function","doc":"","title":"Sobelow.get_mod/1","ref":"Sobelow.html#get_mod/1"},{"type":"function","doc":"","title":"Sobelow.log_finding/1","ref":"Sobelow.html#log_finding/1"},{"type":"function","doc":"","title":"Sobelow.log_finding/2","ref":"Sobelow.html#log_finding/2"},{"type":"function","doc":"","title":"Sobelow.loggable?/2","ref":"Sobelow.html#loggable?/2"},{"type":"function","doc":"","title":"Sobelow.meets_threshold?/1","ref":"Sobelow.html#meets_threshold?/1"},{"type":"function","doc":"","title":"Sobelow.output_format/0","ref":"Sobelow.html#output_format/0"},{"type":"function","doc":"","title":"Sobelow.rules/0","ref":"Sobelow.html#rules/0"},{"type":"function","doc":"","title":"Sobelow.run/0","ref":"Sobelow.html#run/0"},{"type":"function","doc":"","title":"Sobelow.save_config/1","ref":"Sobelow.html#save_config/1"},{"type":"function","doc":"","title":"Sobelow.version/0","ref":"Sobelow.html#version/0"},{"type":"function","doc":"","title":"Sobelow.vuln?/1","ref":"Sobelow.html#vuln?/1"},{"type":"module","doc":"# Command Injection\n\nCommand Injection vulnerabilities are a result of\npassing untrusted input to an operating system shell,\nand may result in complete system compromise.\n\nRead more about Command Injection here:\nhttps://www.owasp.org/index.php/Command_Injection\n\nIf you wish to learn more about the specific vulnerabilities\nfound within the Command Injection category, you may run the\nfollowing commands to find out more:\n\n      $ mix sobelow -d CI.OS\n      $ mix sobelow -d CI.System\n\nCommand Injection checks of all types can be ignored with the\nfollowing command:\n\n    $ mix sobelow -i CI","title":"Sobelow.CI","ref":"Sobelow.CI.html"},{"type":"function","doc":"","title":"Sobelow.CI.details/0","ref":"Sobelow.CI.html#details/0"},{"type":"function","doc":"","title":"Sobelow.CI.finding_modules/0","ref":"Sobelow.CI.html#finding_modules/0"},{"type":"function","doc":"","title":"Sobelow.CI.get_vulns/4","ref":"Sobelow.CI.html#get_vulns/4"},{"type":"function","doc":"","title":"Sobelow.CI.rules/0","ref":"Sobelow.CI.html#rules/0"},{"type":"module","doc":"# Command Injection in `:os.cmd`\n\nThis submodule of the `CI` module checks for Command Injection\nvulnerabilities through usage of the `:os.cmd` function.\n\nEnsure the the command passed to `:os.cmd` is not user-controlled.\n\n`:os.cmd` Injection checks can be ignored with the following command:\n\n    $ mix sobelow -i CI.OS","title":"Sobelow.CI.OS","ref":"Sobelow.CI.OS.html"},{"type":"function","doc":"","title":"Sobelow.CI.OS.details/0","ref":"Sobelow.CI.OS.html#details/0"},{"type":"function","doc":"","title":"Sobelow.CI.OS.id/0","ref":"Sobelow.CI.OS.html#id/0"},{"type":"function","doc":"","title":"Sobelow.CI.OS.parse_def/1","ref":"Sobelow.CI.OS.html#parse_def/1"},{"type":"function","doc":"","title":"Sobelow.CI.OS.rule/0","ref":"Sobelow.CI.OS.html#rule/0"},{"type":"function","doc":"","title":"Sobelow.CI.OS.run/2","ref":"Sobelow.CI.OS.html#run/2"},{"type":"module","doc":"# Command Injection via `System`\n\nThis submodule of the `CI` module checks for Command Injection\nvulnerabilities through usage of the `System.cmd` function.\n\nEnsure the the command passed to `System.cmd` is not user-controlled.\n\n`System.cmd` Injection checks can be ignored with the following command:\n\n    $ mix sobelow -i CI.System","title":"Sobelow.CI.System","ref":"Sobelow.CI.System.html"},{"type":"function","doc":"","title":"Sobelow.CI.System.details/0","ref":"Sobelow.CI.System.html#details/0"},{"type":"function","doc":"","title":"Sobelow.CI.System.id/0","ref":"Sobelow.CI.System.html#id/0"},{"type":"function","doc":"","title":"Sobelow.CI.System.parse_def/1","ref":"Sobelow.CI.System.html#parse_def/1"},{"type":"function","doc":"","title":"Sobelow.CI.System.parse_def_shell/1","ref":"Sobelow.CI.System.html#parse_def_shell/1"},{"type":"function","doc":"","title":"Sobelow.CI.System.rule/0","ref":"Sobelow.CI.System.html#rule/0"},{"type":"function","doc":"","title":"Sobelow.CI.System.run/2","ref":"Sobelow.CI.System.html#run/2"},{"type":"module","doc":"# Configuration\n\nSubmodules contained within this vulnerability type\nare related to common insecurities found in how\nPhoenix applications are configured.\n\nThis can include things like missing headers,\ninsecure cookies, and more.\n\nIf you wish to learn more about the specific vulnerabilities\nfound within the Configuration category, you may run the\nfollowing commands to find out more:\n\n          $ mix sobelow -d Config.CSP\n          $ mix sobelow -d Config.CSRF\n          $ mix sobelow -d Config.CSRFRoute\n          $ mix sobelow -d Config.CSWH\n          $ mix sobelow -d Config.Headers\n          $ mix sobelow -d Config.Secrets\n          $ mix sobelow -d Config.HTTPS\n          $ mix sobelow -d Config.HSTS\n\nConfiguration checks of all types can be ignored with the\nfollowing command:\n\n    $ mix sobelow -i Config","title":"Sobelow.Config","ref":"Sobelow.Config.html"},{"type":"function","doc":"","title":"Sobelow.Config.details/0","ref":"Sobelow.Config.html#details/0"},{"type":"function","doc":"","title":"Sobelow.Config.fetch/3","ref":"Sobelow.Config.html#fetch/3"},{"type":"function","doc":"","title":"Sobelow.Config.finding_modules/0","ref":"Sobelow.Config.html#finding_modules/0"},{"type":"function","doc":"","title":"Sobelow.Config.get_configs/2","ref":"Sobelow.Config.html#get_configs/2"},{"type":"function","doc":"","title":"Sobelow.Config.get_configs_by_file/2","ref":"Sobelow.Config.html#get_configs_by_file/2"},{"type":"function","doc":"","title":"Sobelow.Config.get_fuzzy_configs/2","ref":"Sobelow.Config.html#get_fuzzy_configs/2"},{"type":"function","doc":"","title":"Sobelow.Config.get_pipelines/1","ref":"Sobelow.Config.html#get_pipelines/1"},{"type":"function","doc":"","title":"Sobelow.Config.get_plug_accepts/1","ref":"Sobelow.Config.html#get_plug_accepts/1"},{"type":"function","doc":"","title":"Sobelow.Config.get_plug_list/1","ref":"Sobelow.Config.html#get_plug_list/1"},{"type":"function","doc":"","title":"Sobelow.Config.get_version/1","ref":"Sobelow.Config.html#get_version/1"},{"type":"function","doc":"","title":"Sobelow.Config.get_version/2","ref":"Sobelow.Config.html#get_version/2"},{"type":"function","doc":"","title":"Sobelow.Config.parse_accepts/1","ref":"Sobelow.Config.html#parse_accepts/1"},{"type":"function","doc":"","title":"Sobelow.Config.plug?/2","ref":"Sobelow.Config.html#plug?/2"},{"type":"function","doc":"","title":"Sobelow.Config.rules/0","ref":"Sobelow.Config.html#rules/0"},{"type":"function","doc":"","title":"Sobelow.Config.vuln_pipeline?/2","ref":"Sobelow.Config.html#vuln_pipeline?/2"},{"type":"module","doc":"# Missing Content-Security-Policy\n\nContent-Security-Policy is an HTTP header that helps mitigate\na number of attacks, including Cross-Site Scripting.\n\nRead more about CSP here:\nhttps://developer.mozilla.org/en-US/docs/Web/HTTP/CSP\n\nMissing Content-Security-Policy is flagged by `sobelow` when\na pipeline implements the `:put_secure_browser_headers` plug,\nbut does not provide a Content-Security-Policy header in the\ncustom headers map.\n\nWhen it comes to CSP, just about any policy is better than none.\nIf you are unsure about which policy to use, the following\nmitigates most typical XSS vectors:\n\n`plug :put_secure_browser_headers, %{\"content-security-policy\" => \"default-src 'self'\"}`\n\nDocumentation on the `put_secure_browser_headers` plug function\ncan be found here:\nhttps://hexdocs.pm/phoenix/Phoenix.Controller.html#put_secure_browser_headers/2\n\nContent-Security-Policy checks can be ignored with the following command:\n\n    $ mix sobelow -i Config.CSP","title":"Sobelow.Config.CSP","ref":"Sobelow.Config.CSP.html"},{"type":"function","doc":"","title":"Sobelow.Config.CSP.check_vuln_pipeline/2","ref":"Sobelow.Config.CSP.html#check_vuln_pipeline/2"},{"type":"function","doc":"","title":"Sobelow.Config.CSP.details/0","ref":"Sobelow.Config.CSP.html#details/0"},{"type":"function","doc":"","title":"Sobelow.Config.CSP.id/0","ref":"Sobelow.Config.CSP.html#id/0"},{"type":"function","doc":"","title":"Sobelow.Config.CSP.rule/0","ref":"Sobelow.Config.CSP.html#rule/0"},{"type":"function","doc":"","title":"Sobelow.Config.CSP.run/1","ref":"Sobelow.Config.CSP.html#run/1"},{"type":"module","doc":"# Cross-Site Request Forgery\n\nIn a Cross-Site Request Forgery (CSRF) attack, an untrusted\napplication can cause a user's browser to submit requests or perform\nactions on the user's behalf.\n\nRead more about CSRF here:\nhttps://owasp.org/www-community/attacks/csrf\n\nCross-Site Request Forgery is flagged by `sobelow` when\na pipeline fetches a session, but does not implement the\n`:protect_from_forgery` plug.\n\nCSRF checks can be ignored with the following command:\n\n    $ mix sobelow -i Config.CSRF","title":"Sobelow.Config.CSRF","ref":"Sobelow.Config.CSRF.html"},{"type":"function","doc":"","title":"Sobelow.Config.CSRF.details/0","ref":"Sobelow.Config.CSRF.html#details/0"},{"type":"function","doc":"","title":"Sobelow.Config.CSRF.id/0","ref":"Sobelow.Config.CSRF.html#id/0"},{"type":"function","doc":"","title":"Sobelow.Config.CSRF.rule/0","ref":"Sobelow.Config.CSRF.html#rule/0"},{"type":"function","doc":"","title":"Sobelow.Config.CSRF.run/1","ref":"Sobelow.Config.CSRF.html#run/1"},{"type":"module","doc":"# Cross-Site Request Forgery\n\nIn a Cross-Site Request Forgery (CSRF) attack, an untrusted\napplication can cause a user's browser to submit requests or perform\nactions on the user's behalf.\n\nRead more about CSRF here:\nhttps://www.owasp.org/index.php/Cross-Site_Request_Forgery_(CSRF)\n\nThis type of CSRF is flagged by `sobelow` when state-changing\nroutes share an action with GET-based routes. For example:\n\n    get \"/users\", UserController, :new\n    post \"/users\", UserController, :new\n\nIn this instance, it may be possible to trigger the POST\nfunctionality with a GET request and query parameters.\n\nCSRF checks can be ignored with the following command:\n\n    $ mix sobelow -i Config.CSRFRoute","title":"Sobelow.Config.CSRFRoute","ref":"Sobelow.Config.CSRFRoute.html"},{"type":"function","doc":"","title":"Sobelow.Config.CSRFRoute.combine_scopes/1","ref":"Sobelow.Config.CSRFRoute.html#combine_scopes/1"},{"type":"function","doc":"","title":"Sobelow.Config.CSRFRoute.details/0","ref":"Sobelow.Config.CSRFRoute.html#details/0"},{"type":"function","doc":"","title":"Sobelow.Config.CSRFRoute.id/0","ref":"Sobelow.Config.CSRFRoute.html#id/0"},{"type":"function","doc":"","title":"Sobelow.Config.CSRFRoute.route_findings/2","ref":"Sobelow.Config.CSRFRoute.html#route_findings/2"},{"type":"function","doc":"","title":"Sobelow.Config.CSRFRoute.rule/0","ref":"Sobelow.Config.CSRFRoute.html#rule/0"},{"type":"function","doc":"","title":"Sobelow.Config.CSRFRoute.run/1","ref":"Sobelow.Config.CSRFRoute.html#run/1"},{"type":"module","doc":"# Cross-Site Websocket Hijacking\n\nWebsocket connections are not bound by the same-origin policy.\nConnections that do not validate the origin may leak information\nto an attacker.\n\nMore information can be found here: https://www.christian-schneider.net/CrossSiteWebSocketHijacking.html\n\nCross-Site Websocket Hijacking checks can be disabled with\nthe following command:\n\n    $ mix sobelow -i Config.CSWH","title":"Sobelow.Config.CSWH","ref":"Sobelow.Config.CSWH.html"},{"type":"function","doc":"","title":"Sobelow.Config.CSWH.check_socket/1","ref":"Sobelow.Config.CSWH.html#check_socket/1"},{"type":"function","doc":"","title":"Sobelow.Config.CSWH.details/0","ref":"Sobelow.Config.CSWH.html#details/0"},{"type":"function","doc":"","title":"Sobelow.Config.CSWH.id/0","ref":"Sobelow.Config.CSWH.html#id/0"},{"type":"function","doc":"","title":"Sobelow.Config.CSWH.rule/0","ref":"Sobelow.Config.CSWH.html#rule/0"},{"type":"function","doc":"","title":"Sobelow.Config.CSWH.run/1","ref":"Sobelow.Config.CSWH.html#run/1"},{"type":"module","doc":"# HSTS\n\nThe HTTP Strict Transport Security (HSTS) header helps\ndefend against man-in-the-middle attacks by preventing\nunencrypted connections.\n\nHSTS checks can be ignored with the following command:\n\n    $ mix sobelow -i Config.HSTS","title":"Sobelow.Config.HSTS","ref":"Sobelow.Config.HSTS.html"},{"type":"function","doc":"","title":"Sobelow.Config.HSTS.details/0","ref":"Sobelow.Config.HSTS.html#details/0"},{"type":"function","doc":"","title":"Sobelow.Config.HSTS.id/0","ref":"Sobelow.Config.HSTS.html#id/0"},{"type":"function","doc":"","title":"Sobelow.Config.HSTS.rule/0","ref":"Sobelow.Config.HSTS.html#rule/0"},{"type":"function","doc":"","title":"Sobelow.Config.HSTS.run/2","ref":"Sobelow.Config.HSTS.html#run/2"},{"type":"module","doc":"# HTTPS\n\nWithout HTTPS, attackers in a privileged network position can\nintercept and modify traffic.\n\nSobelow detects missing HTTPS by checking the prod\nconfiguration.\n\nHTTPS checks can be ignored with the following command:\n\n    $ mix sobelow -i Config.HTTPS","title":"Sobelow.Config.HTTPS","ref":"Sobelow.Config.HTTPS.html"},{"type":"function","doc":"","title":"Sobelow.Config.HTTPS.details/0","ref":"Sobelow.Config.HTTPS.html#details/0"},{"type":"function","doc":"","title":"Sobelow.Config.HTTPS.id/0","ref":"Sobelow.Config.HTTPS.html#id/0"},{"type":"function","doc":"","title":"Sobelow.Config.HTTPS.rule/0","ref":"Sobelow.Config.HTTPS.html#rule/0"},{"type":"function","doc":"","title":"Sobelow.Config.HTTPS.run/2","ref":"Sobelow.Config.HTTPS.html#run/2"},{"type":"module","doc":"# Missing Secure HTTP Headers\n\nBy default, Phoenix HTTP responses contain a number of\nsecure HTTP headers that attempt to mitigate XSS,\nclick-jacking, and content-sniffing attacks.\n\nMissing Secure HTTP Headers is flagged by `sobelow` when\na pipeline accepts \"html\" requests, but does not implement\nthe `:put_secure_browser_headers` plug.\n\nSecure Headers checks can be ignored with the following\ncommand:\n\n    $ mix sobelow -i Config.Headers","title":"Sobelow.Config.Headers","ref":"Sobelow.Config.Headers.html"},{"type":"function","doc":"","title":"Sobelow.Config.Headers.details/0","ref":"Sobelow.Config.Headers.html#details/0"},{"type":"function","doc":"","title":"Sobelow.Config.Headers.id/0","ref":"Sobelow.Config.Headers.html#id/0"},{"type":"function","doc":"","title":"Sobelow.Config.Headers.rule/0","ref":"Sobelow.Config.Headers.html#rule/0"},{"type":"function","doc":"","title":"Sobelow.Config.Headers.run/1","ref":"Sobelow.Config.Headers.html#run/1"},{"type":"module","doc":"# Hard-coded Secrets\n\nIn the event of a source-code disclosure via file read\nvulnerability, accidental commit, etc, hard-coded secrets\nmay be exposed to an attacker. This may result in\ndatabase access, cookie forgery, and other issues.\n\nSobelow detects missing hard-coded secrets by checking the prod\nconfiguration.\n\nHard-coded secrets checks can be ignored with the following command:\n\n    $ mix sobelow -i Config.Secrets","title":"Sobelow.Config.Secrets","ref":"Sobelow.Config.Secrets.html"},{"type":"function","doc":"","title":"Sobelow.Config.Secrets.details/0","ref":"Sobelow.Config.Secrets.html#details/0"},{"type":"function","doc":"","title":"Sobelow.Config.Secrets.env_var?/1","ref":"Sobelow.Config.Secrets.html#env_var?/1"},{"type":"function","doc":"","title":"Sobelow.Config.Secrets.id/0","ref":"Sobelow.Config.Secrets.html#id/0"},{"type":"function","doc":"","title":"Sobelow.Config.Secrets.rule/0","ref":"Sobelow.Config.Secrets.html#rule/0"},{"type":"function","doc":"","title":"Sobelow.Config.Secrets.run/2","ref":"Sobelow.Config.Secrets.html#run/2"},{"type":"module","doc":"# Denial of Service\n\nThe Denial of Service (DOS) attack is focused on making a\nresource (site, application, server) unavailable for the\npurpose it was designed.\n\nRead more about Denial of Service here:\nhttps://owasp.org/www-community/attacks/Denial_of_Service\n\nIf you wish to learn more about the specific vulnerabilities\nfound within the Denial of Service category, you may run the\nfollowing commands to find out more:\n\n        $ mix sobelow -d DOS.StringToAtom\n        $ mix sobelow -d DOS.ListToAtom\n        $ mix sobelow -d DOS.BinToAtom\n\nDenial of Service checks of all types can be ignored with the\nfollowing command:\n\n    $ mix sobelow -i DOS","title":"Sobelow.DOS","ref":"Sobelow.DOS.html"},{"type":"function","doc":"","title":"Sobelow.DOS.details/0","ref":"Sobelow.DOS.html#details/0"},{"type":"function","doc":"","title":"Sobelow.DOS.finding_modules/0","ref":"Sobelow.DOS.html#finding_modules/0"},{"type":"function","doc":"","title":"Sobelow.DOS.get_vulns/4","ref":"Sobelow.DOS.html#get_vulns/4"},{"type":"function","doc":"","title":"Sobelow.DOS.rules/0","ref":"Sobelow.DOS.html#rules/0"},{"type":"module","doc":"# Denial of Service via Unsafe Atom Interpolation\n\nIn Elixir, atoms are not garbage collected. As such, if user input\nis used to create atoms (as in `:\"foo#{bar}\"`, or in `:erlang.binary_to_atom`),\nit may result in memory exhaustion. Prefer the `String.to_existing_atom`\nfunction for untrusted user input.\n\nAtom interpolation checks can be ignored with the following command:\n\n    $ mix sobelow -i DOS.BinToAtom","title":"Sobelow.DOS.BinToAtom","ref":"Sobelow.DOS.BinToAtom.html"},{"type":"function","doc":"","title":"Sobelow.DOS.BinToAtom.details/0","ref":"Sobelow.DOS.BinToAtom.html#details/0"},{"type":"function","doc":"","title":"Sobelow.DOS.BinToAtom.id/0","ref":"Sobelow.DOS.BinToAtom.html#id/0"},{"type":"function","doc":"","title":"Sobelow.DOS.BinToAtom.parse_def/1","ref":"Sobelow.DOS.BinToAtom.html#parse_def/1"},{"type":"function","doc":"","title":"Sobelow.DOS.BinToAtom.rule/0","ref":"Sobelow.DOS.BinToAtom.html#rule/0"},{"type":"function","doc":"","title":"Sobelow.DOS.BinToAtom.run/2","ref":"Sobelow.DOS.BinToAtom.html#run/2"},{"type":"module","doc":"# Denial of Service via `List.to_atom`\n\nIn Elixir, atoms are not garbage collected. As such, if user input\nis passed to the `List.to_atom` function, it may result in memory\nexhaustion. Prefer the `List.to_existing_atom` function for untrusted\nuser input.\n\n`List.to_atom` checks can be ignored with the following command:\n\n    $ mix sobelow -i DOS.ListToAtom","title":"Sobelow.DOS.ListToAtom","ref":"Sobelow.DOS.ListToAtom.html"},{"type":"function","doc":"","title":"Sobelow.DOS.ListToAtom.details/0","ref":"Sobelow.DOS.ListToAtom.html#details/0"},{"type":"function","doc":"","title":"Sobelow.DOS.ListToAtom.id/0","ref":"Sobelow.DOS.ListToAtom.html#id/0"},{"type":"function","doc":"","title":"Sobelow.DOS.ListToAtom.parse_def/1","ref":"Sobelow.DOS.ListToAtom.html#parse_def/1"},{"type":"function","doc":"","title":"Sobelow.DOS.ListToAtom.rule/0","ref":"Sobelow.DOS.ListToAtom.html#rule/0"},{"type":"function","doc":"","title":"Sobelow.DOS.ListToAtom.run/2","ref":"Sobelow.DOS.ListToAtom.html#run/2"},{"type":"module","doc":"# Denial of Service via `String.to_atom`\n\nIn Elixir, atoms are not garbage collected. As such, if user input\nis passed to the `String.to_atom` function, it may result in memory\nexhaustion. Prefer the `String.to_existing_atom` function for untrusted\nuser input.\n\n`String.to_atom` checks can be ignored with the following command:\n\n    $ mix sobelow -i DOS.StringToAtom","title":"Sobelow.DOS.StringToAtom","ref":"Sobelow.DOS.StringToAtom.html"},{"type":"function","doc":"","title":"Sobelow.DOS.StringToAtom.details/0","ref":"Sobelow.DOS.StringToAtom.html#details/0"},{"type":"function","doc":"","title":"Sobelow.DOS.StringToAtom.id/0","ref":"Sobelow.DOS.StringToAtom.html#id/0"},{"type":"function","doc":"","title":"Sobelow.DOS.StringToAtom.parse_def/1","ref":"Sobelow.DOS.StringToAtom.html#parse_def/1"},{"type":"function","doc":"","title":"Sobelow.DOS.StringToAtom.rule/0","ref":"Sobelow.DOS.StringToAtom.html#rule/0"},{"type":"function","doc":"","title":"Sobelow.DOS.StringToAtom.run/2","ref":"Sobelow.DOS.StringToAtom.html#run/2"},{"type":"module","doc":"IO helpers. Mostly mirror Mix.Shell.IO, but Mix will not always be available\nto Sobelow.","title":"Sobelow.IO","ref":"Sobelow.IO.html"},{"type":"function","doc":"","title":"Sobelow.IO.error/1","ref":"Sobelow.IO.html#error/1"},{"type":"function","doc":"","title":"Sobelow.IO.info/1","ref":"Sobelow.IO.html#info/1"},{"type":"function","doc":"","title":"Sobelow.IO.yes?/1","ref":"Sobelow.IO.html#yes?/1"},{"type":"module","doc":"# Miscellaneous\n\nThis suite of tests is to be a catch-all for\nchecks that don't fall neatly into the other\ndetection categories.\n\nIf you wish to learn more about the specific vulnerabilities\nfound within the Miscellaneous category, you may run the\nfollowing commands to find out more:\n\n          $ mix sobelow -d Misc.BinToTerm\n\nMiscellaneous checks of all types can be ignored with the\nfollowing command:\n\n    $ mix sobelow -i Misc","title":"Sobelow.Misc","ref":"Sobelow.Misc.html"},{"type":"function","doc":"","title":"Sobelow.Misc.details/0","ref":"Sobelow.Misc.html#details/0"},{"type":"function","doc":"","title":"Sobelow.Misc.finding_modules/0","ref":"Sobelow.Misc.html#finding_modules/0"},{"type":"function","doc":"","title":"Sobelow.Misc.get_vulns/4","ref":"Sobelow.Misc.html#get_vulns/4"},{"type":"function","doc":"","title":"Sobelow.Misc.rules/0","ref":"Sobelow.Misc.html#rules/0"},{"type":"module","doc":"# Insecure use of `binary_to_term`\n\nIf user input is passed to Erlang's `binary_to_term` function\nit may result in memory exhaustion or code execution. Even with\nthe `:safe` option, `binary_to_term` will deserialize functions,\nand shouldn't be considered safe to use with untrusted input.\n\n`binary_to_term` checks can be ignored with the following command:\n\n    $ mix sobelow -i Misc.BinToTerm","title":"Sobelow.Misc.BinToTerm","ref":"Sobelow.Misc.BinToTerm.html"},{"type":"function","doc":"","title":"Sobelow.Misc.BinToTerm.details/0","ref":"Sobelow.Misc.BinToTerm.html#details/0"},{"type":"function","doc":"","title":"Sobelow.Misc.BinToTerm.id/0","ref":"Sobelow.Misc.BinToTerm.html#id/0"},{"type":"function","doc":"","title":"Sobelow.Misc.BinToTerm.parse_def/1","ref":"Sobelow.Misc.BinToTerm.html#parse_def/1"},{"type":"function","doc":"","title":"Sobelow.Misc.BinToTerm.rule/0","ref":"Sobelow.Misc.BinToTerm.html#rule/0"},{"type":"function","doc":"","title":"Sobelow.Misc.BinToTerm.run/2","ref":"Sobelow.Misc.BinToTerm.html#run/2"},{"type":"module","doc":"# Insecure use of `File` and `Path`\n\nNote: This check has been deprecated. File/Path issues were\naddressed with the release of OTP 21.\n\nIn Elixir, `File` methods are null-terminated, while `Path`\nfunctions are not. This may cause security issues in certain\nsituations. For example:\n\n```\nuser_input = \"/var/www/secret.txt\\0/name\"\n\npath = Path.dirname(user_input)\npublic_file = path <> \"/public.txt\"\n\nFile.read(public_file)\n```\n\nBecause `Path` functions are not null-terminated, this\nwill attempt to read the file, \"/var/www/secret.txt\\\\0/public.txt\".\nHowever, due to the null-byte termination of `File` functions\n\"secret.txt\" will ultimately be read.\n\n`File/Path` checks can be ignored with the following command:\n\n    $ mix sobelow -i Misc.FilePath","title":"Sobelow.Misc.FilePath","ref":"Sobelow.Misc.FilePath.html"},{"type":"module","doc":"# Remote Code Execution\n\nRemote Code Execution vulnerabilities are a result of\nuntrusted user input being executed or interpreted by\nthe system and may result in complete system compromise.\n\nIf you wish to learn more about the specific vulnerabilities\nfound within the Remote Code Execution category, you may run the\nfollowing commands to find out more:\n\n        $ mix sobelow -d RCE.EEx\n        $ mix sobelow -d RCE.CodeModule\n\nRemote Code Execution checks of all types can be ignored with the\nfollowing command:\n\n    $ mix sobelow -i RCE","title":"Sobelow.RCE","ref":"Sobelow.RCE.html"},{"type":"function","doc":"","title":"Sobelow.RCE.details/0","ref":"Sobelow.RCE.html#details/0"},{"type":"function","doc":"","title":"Sobelow.RCE.finding_modules/0","ref":"Sobelow.RCE.html#finding_modules/0"},{"type":"function","doc":"","title":"Sobelow.RCE.get_vulns/4","ref":"Sobelow.RCE.html#get_vulns/4"},{"type":"function","doc":"","title":"Sobelow.RCE.rules/0","ref":"Sobelow.RCE.html#rules/0"},{"type":"module","doc":"# Code Execution in `eval` function\n\nArbitrary strings passed to the `Code.eval_*` functions can be\nexecuted as malicious code.\n\nEnsure the the code passed to the function is not user-controlled\nor remove the function call completely.\n\nRead more about Elixir RCE here:\nhttps://erlef.github.io/security-wg/secure_coding_and_deployment_hardening/sandboxing\n\nCode Execution checks can be ignored with the following command:\n\n    $ mix sobelow -i RCE.CodeModule","title":"Sobelow.RCE.CodeModule","ref":"Sobelow.RCE.CodeModule.html"},{"type":"function","doc":"","title":"Sobelow.RCE.CodeModule.details/0","ref":"Sobelow.RCE.CodeModule.html#details/0"},{"type":"function","doc":"","title":"Sobelow.RCE.CodeModule.id/0","ref":"Sobelow.RCE.CodeModule.html#id/0"},{"type":"function","doc":"","title":"Sobelow.RCE.CodeModule.parse_def/2","ref":"Sobelow.RCE.CodeModule.html#parse_def/2"},{"type":"function","doc":"","title":"Sobelow.RCE.CodeModule.rule/0","ref":"Sobelow.RCE.CodeModule.html#rule/0"},{"type":"function","doc":"","title":"Sobelow.RCE.CodeModule.run/2","ref":"Sobelow.RCE.CodeModule.html#run/2"},{"type":"module","doc":"# Insecure EEx evaluation\n\nIf user input is passed to EEx eval functions, it may result in\narbitrary code execution. The root cause of these issues is often\ndirectory traversal.\n\nEEx checks can be ignored with the following command:\n\n    $ mix sobelow -i RCE.EEx","title":"Sobelow.RCE.EEx","ref":"Sobelow.RCE.EEx.html"},{"type":"function","doc":"","title":"Sobelow.RCE.EEx.details/0","ref":"Sobelow.RCE.EEx.html#details/0"},{"type":"function","doc":"","title":"Sobelow.RCE.EEx.id/0","ref":"Sobelow.RCE.EEx.html#id/0"},{"type":"function","doc":"","title":"Sobelow.RCE.EEx.parse_def/2","ref":"Sobelow.RCE.EEx.html#parse_def/2"},{"type":"function","doc":"","title":"Sobelow.RCE.EEx.rule/0","ref":"Sobelow.RCE.EEx.html#rule/0"},{"type":"function","doc":"","title":"Sobelow.RCE.EEx.run/2","ref":"Sobelow.RCE.EEx.html#run/2"},{"type":"module","doc":"# SQL Injection\n\nSQL Injection occurs when untrusted input is interpolated\ndirectly into a SQL query. In a typical Phoenix application,\nthis would mean using the `Ecto.Adapters.SQL.query` method\nand not using the parameterization feature.\n\nRead more about SQL injection here:\nhttps://www.owasp.org/index.php/SQL_Injection\n\nIf you wish to learn more about the specific vulnerabilities\nfound within the SQL Injection category, you may run the\nfollowing commands to find out more:\n\n          $ mix sobelow -d SQL.Query\n          $ mix sobelow -d SQL.Stream\n\nSQL Injection checks of all types can be ignored with the following command:\n\n    $ mix sobelow -i SQL","title":"Sobelow.SQL","ref":"Sobelow.SQL.html"},{"type":"function","doc":"","title":"Sobelow.SQL.details/0","ref":"Sobelow.SQL.html#details/0"},{"type":"function","doc":"","title":"Sobelow.SQL.finding_modules/0","ref":"Sobelow.SQL.html#finding_modules/0"},{"type":"function","doc":"","title":"Sobelow.SQL.get_vulns/4","ref":"Sobelow.SQL.html#get_vulns/4"},{"type":"function","doc":"","title":"Sobelow.SQL.rules/0","ref":"Sobelow.SQL.html#rules/0"},{"type":"module","doc":"# SQL Injection in Query\n\nThis submodule of the `SQL` module checks for SQL injection\nvulnerabilities through usage of the `Ecto.Adapters.SQL.query`\nand `Ecto.Adapters.SQL.query!`.\n\nEnsure that the query is parameterized and not user-controlled.\n\nSQLi Query checks can be ignored with the following command:\n\n    $ mix sobelow -i SQL.Query","title":"Sobelow.SQL.Query","ref":"Sobelow.SQL.Query.html"},{"type":"function","doc":"","title":"Sobelow.SQL.Query.details/0","ref":"Sobelow.SQL.Query.html#details/0"},{"type":"function","doc":"","title":"Sobelow.SQL.Query.id/0","ref":"Sobelow.SQL.Query.html#id/0"},{"type":"function","doc":"","title":"Sobelow.SQL.Query.parse_repo_query_def/2","ref":"Sobelow.SQL.Query.html#parse_repo_query_def/2"},{"type":"function","doc":"","title":"Sobelow.SQL.Query.parse_sql_def/2","ref":"Sobelow.SQL.Query.html#parse_sql_def/2"},{"type":"function","doc":"","title":"Sobelow.SQL.Query.rule/0","ref":"Sobelow.SQL.Query.html#rule/0"},{"type":"function","doc":"","title":"Sobelow.SQL.Query.run/2","ref":"Sobelow.SQL.Query.html#run/2"},{"type":"module","doc":"# SQL Injection in Stream\n\nThis submodule of the `SQL` module checks for SQL injection\nvulnerabilities through usage of the `Ecto.Adapters.SQL.stream`.\n\nEnsure that the query is parameterized and not user-controlled.\n\nSQLi Stream checks can be ignored with the following command:\n\n    $ mix sobelow -i SQL.Stream","title":"Sobelow.SQL.Stream","ref":"Sobelow.SQL.Stream.html"},{"type":"function","doc":"","title":"Sobelow.SQL.Stream.details/0","ref":"Sobelow.SQL.Stream.html#details/0"},{"type":"function","doc":"","title":"Sobelow.SQL.Stream.id/0","ref":"Sobelow.SQL.Stream.html#id/0"},{"type":"function","doc":"","title":"Sobelow.SQL.Stream.parse_sql_def/1","ref":"Sobelow.SQL.Stream.html#parse_sql_def/1"},{"type":"function","doc":"","title":"Sobelow.SQL.Stream.rule/0","ref":"Sobelow.SQL.Stream.html#rule/0"},{"type":"function","doc":"","title":"Sobelow.SQL.Stream.run/2","ref":"Sobelow.SQL.Stream.html#run/2"},{"type":"module","doc":"# Path Traversal\n\nPath traversal vulnerabilities are a result of\ninteracting with the filesystem using untrusted input.\nThis class of vulnerability may result in file disclosure,\ncode execution, denial of service, and other issues.\n\nRead more about Path Traversal here:\nhttps://www.owasp.org/index.php/Path_Traversal\n\nIf you wish to learn more about the specific vulnerabilities\nfound within the Path Traversal category, you may run the\nfollowing commands to find out more:\n\n          $ mix sobelow -d Traversal.SendFile\n          $ mix sobelow -d Traversal.FileModule\n          $ mix sobelow -d Traversal.SendDownload\n\nPath Traversal checks of all types can be ignored with the following command:\n\n    $ mix sobelow -i Traversal","title":"Sobelow.Traversal","ref":"Sobelow.Traversal.html"},{"type":"function","doc":"","title":"Sobelow.Traversal.details/0","ref":"Sobelow.Traversal.html#details/0"},{"type":"function","doc":"","title":"Sobelow.Traversal.finding_modules/0","ref":"Sobelow.Traversal.html#finding_modules/0"},{"type":"function","doc":"","title":"Sobelow.Traversal.get_vulns/4","ref":"Sobelow.Traversal.html#get_vulns/4"},{"type":"function","doc":"","title":"Sobelow.Traversal.rules/0","ref":"Sobelow.Traversal.html#rules/0"},{"type":"module","doc":"# Directory Traversal in `File` function\n\nThis submodule checks for directory traversal vulnerabilities in the `File`\nmodule.\n\nEnsure that the path passed to `File` functions is not user-controlled.\n\nFile checks can be ignored with the following command:\n\n    $ mix sobelow -i Traversal.FileModule","title":"Sobelow.Traversal.FileModule","ref":"Sobelow.Traversal.FileModule.html"},{"type":"function","doc":"","title":"Sobelow.Traversal.FileModule.details/0","ref":"Sobelow.Traversal.FileModule.html#details/0"},{"type":"function","doc":"","title":"Sobelow.Traversal.FileModule.id/0","ref":"Sobelow.Traversal.FileModule.html#id/0"},{"type":"function","doc":"","title":"Sobelow.Traversal.FileModule.parse_def/2","ref":"Sobelow.Traversal.FileModule.html#parse_def/2"},{"type":"function","doc":"","title":"Sobelow.Traversal.FileModule.parse_second_def/2","ref":"Sobelow.Traversal.FileModule.html#parse_second_def/2"},{"type":"function","doc":"","title":"Sobelow.Traversal.FileModule.rule/0","ref":"Sobelow.Traversal.FileModule.html#rule/0"},{"type":"function","doc":"","title":"Sobelow.Traversal.FileModule.run/2","ref":"Sobelow.Traversal.FileModule.html#run/2"},{"type":"module","doc":"# Directory Traversal in `send_download`\n\nThis submodule checks for directory traversal vulnerabilities in the\n`send_download` function of a Phoenix Controller.\n\nEnsure that the path passed to `send_download` is not user-controlled.\n\nSend Download checks can be ignored with the following command:\n\n    $ mix sobelow -i Traversal.SendDownload","title":"Sobelow.Traversal.SendDownload","ref":"Sobelow.Traversal.SendDownload.html"},{"type":"function","doc":"","title":"Sobelow.Traversal.SendDownload.details/0","ref":"Sobelow.Traversal.SendDownload.html#details/0"},{"type":"function","doc":"","title":"Sobelow.Traversal.SendDownload.id/0","ref":"Sobelow.Traversal.SendDownload.html#id/0"},{"type":"function","doc":"","title":"Sobelow.Traversal.SendDownload.parse_def/1","ref":"Sobelow.Traversal.SendDownload.html#parse_def/1"},{"type":"function","doc":"","title":"Sobelow.Traversal.SendDownload.rule/0","ref":"Sobelow.Traversal.SendDownload.html#rule/0"},{"type":"function","doc":"","title":"Sobelow.Traversal.SendDownload.run/2","ref":"Sobelow.Traversal.SendDownload.html#run/2"},{"type":"module","doc":"# Directory Traversal in `send_file`\n\nThis submodule checks for directory traversal vulnerabilities in the\n`send_file` function.\n\nEnsure that the path passed to `send_file` is not user-controlled.\n\nSend File checks can be ignored with the following command:\n\n    $ mix sobelow -i Traversal.SendFile","title":"Sobelow.Traversal.SendFile","ref":"Sobelow.Traversal.SendFile.html"},{"type":"function","doc":"","title":"Sobelow.Traversal.SendFile.details/0","ref":"Sobelow.Traversal.SendFile.html#details/0"},{"type":"function","doc":"","title":"Sobelow.Traversal.SendFile.id/0","ref":"Sobelow.Traversal.SendFile.html#id/0"},{"type":"function","doc":"","title":"Sobelow.Traversal.SendFile.parse_def/1","ref":"Sobelow.Traversal.SendFile.html#parse_def/1"},{"type":"function","doc":"","title":"Sobelow.Traversal.SendFile.rule/0","ref":"Sobelow.Traversal.SendFile.html#rule/0"},{"type":"function","doc":"","title":"Sobelow.Traversal.SendFile.run/2","ref":"Sobelow.Traversal.SendFile.html#run/2"},{"type":"module","doc":"# Known Vulnerable Dependencies\n\nAn application with known vulnerabilities is more easily subjected\nto automated or targeted attacks.\n\nIf you wish to learn more about the specific vulnerabilities\nfound within the Known Vulnerable Dependencies category, you may run the\nfollowing commands to find out more:\n\n          $ mix sobelow -d Vuln.PlugNull\n          $ mix sobelow -d Vuln.CookieRCE\n          $ mix sobelow -d Vuln.HeaderInject\n          $ mix sobelow -d Vuln.Redirect\n          $ mix sobelow -d Vuln.Coherence\n          $ mix sobelow -d Vuln.Ecto\n\nKnown Vulnerable checks of all types can be ignored with the following command:\n\n    $ mix sobelow -i Vuln","title":"Sobelow.Vuln","ref":"Sobelow.Vuln.html"},{"type":"function","doc":"","title":"Sobelow.Vuln.details/0","ref":"Sobelow.Vuln.html#details/0"},{"type":"function","doc":"","title":"Sobelow.Vuln.finding_modules/0","ref":"Sobelow.Vuln.html#finding_modules/0"},{"type":"function","doc":"","title":"Sobelow.Vuln.get_vulns/1","ref":"Sobelow.Vuln.html#get_vulns/1"},{"type":"function","doc":"","title":"Sobelow.Vuln.print_finding/6","ref":"Sobelow.Vuln.html#print_finding/6"},{"type":"function","doc":"","title":"Sobelow.Vuln.rules/0","ref":"Sobelow.Vuln.html#rules/0"},{"type":"module","doc":"# Coherence Version Vulnerable to Privilege Escalation\n\nFor more information visit:\nhttps://github.com/advisories/GHSA-mrq8-53r4-3j5m\n\nCoherence checks can be ignored with the following command:\n\n    $ mix sobelow -i Vuln.Coherence","title":"Sobelow.Vuln.Coherence","ref":"Sobelow.Vuln.Coherence.html"},{"type":"function","doc":"","title":"Sobelow.Vuln.Coherence.details/0","ref":"Sobelow.Vuln.Coherence.html#details/0"},{"type":"function","doc":"","title":"Sobelow.Vuln.Coherence.id/0","ref":"Sobelow.Vuln.Coherence.html#id/0"},{"type":"function","doc":"","title":"Sobelow.Vuln.Coherence.rule/0","ref":"Sobelow.Vuln.Coherence.html#rule/0"},{"type":"function","doc":"","title":"Sobelow.Vuln.Coherence.run/1","ref":"Sobelow.Vuln.Coherence.html#run/1"},{"type":"module","doc":"# Plug Version Vulnerable to Arbitrary Code Execution in Cookie Serialization\n\nFor more information visit:\nhttps://github.com/advisories/GHSA-5v4m-c73v-c7gq\n\nCookie RCE checks can be ignored with the following command:\n\n    $ mix sobelow -i Vuln.CookieRCE","title":"Sobelow.Vuln.CookieRCE","ref":"Sobelow.Vuln.CookieRCE.html"},{"type":"function","doc":"","title":"Sobelow.Vuln.CookieRCE.details/0","ref":"Sobelow.Vuln.CookieRCE.html#details/0"},{"type":"function","doc":"","title":"Sobelow.Vuln.CookieRCE.id/0","ref":"Sobelow.Vuln.CookieRCE.html#id/0"},{"type":"function","doc":"","title":"Sobelow.Vuln.CookieRCE.rule/0","ref":"Sobelow.Vuln.CookieRCE.html#rule/0"},{"type":"function","doc":"","title":"Sobelow.Vuln.CookieRCE.run/1","ref":"Sobelow.Vuln.CookieRCE.html#run/1"},{"type":"module","doc":"# Ecto Version Lacks Protection Mechanism\n\nFor more information visit:\nhttps://github.com/advisories/GHSA-2xxx-fhc8-9qvq\n\nEcto checks can be ignored with the following command:\n\n    $ mix sobelow -i Vuln.Ecto","title":"Sobelow.Vuln.Ecto","ref":"Sobelow.Vuln.Ecto.html"},{"type":"function","doc":"","title":"Sobelow.Vuln.Ecto.details/0","ref":"Sobelow.Vuln.Ecto.html#details/0"},{"type":"function","doc":"","title":"Sobelow.Vuln.Ecto.id/0","ref":"Sobelow.Vuln.Ecto.html#id/0"},{"type":"function","doc":"","title":"Sobelow.Vuln.Ecto.rule/0","ref":"Sobelow.Vuln.Ecto.html#rule/0"},{"type":"function","doc":"","title":"Sobelow.Vuln.Ecto.run/1","ref":"Sobelow.Vuln.Ecto.html#run/1"},{"type":"module","doc":"# Plug Version Vulnerable to Header Injection\n\nFor more information visit:\nhttps://github.com/advisories/GHSA-9h73-w7ch-rh73\n\nHeader Injection checks can be ignored with the following command:\n\n    $ mix sobelow -i Vuln.HeaderInject","title":"Sobelow.Vuln.HeaderInject","ref":"Sobelow.Vuln.HeaderInject.html"},{"type":"function","doc":"","title":"Sobelow.Vuln.HeaderInject.details/0","ref":"Sobelow.Vuln.HeaderInject.html#details/0"},{"type":"function","doc":"","title":"Sobelow.Vuln.HeaderInject.id/0","ref":"Sobelow.Vuln.HeaderInject.html#id/0"},{"type":"function","doc":"","title":"Sobelow.Vuln.HeaderInject.rule/0","ref":"Sobelow.Vuln.HeaderInject.html#rule/0"},{"type":"function","doc":"","title":"Sobelow.Vuln.HeaderInject.run/1","ref":"Sobelow.Vuln.HeaderInject.html#run/1"},{"type":"module","doc":"# Plug Version Vulnerable to Null Byte Injection\n\nFor more information visit:\nhttps://github.com/advisories/GHSA-2q6v-32mr-8p8x\n\nNull Byte Injection checks can be ignored with the following command:\n\n    $ mix sobelow -i Vuln.PlugNull","title":"Sobelow.Vuln.PlugNull","ref":"Sobelow.Vuln.PlugNull.html"},{"type":"function","doc":"","title":"Sobelow.Vuln.PlugNull.details/0","ref":"Sobelow.Vuln.PlugNull.html#details/0"},{"type":"function","doc":"","title":"Sobelow.Vuln.PlugNull.id/0","ref":"Sobelow.Vuln.PlugNull.html#id/0"},{"type":"function","doc":"","title":"Sobelow.Vuln.PlugNull.rule/0","ref":"Sobelow.Vuln.PlugNull.html#rule/0"},{"type":"function","doc":"","title":"Sobelow.Vuln.PlugNull.run/1","ref":"Sobelow.Vuln.PlugNull.html#run/1"},{"type":"module","doc":"# Phoenix Version Vulnerable to Arbitrary URL Redirection\n\nFor more information visit:\nhttps://github.com/advisories/GHSA-cmfh-8f8r-fj96\n\nURL Redirection checks can be ignored with the following command:\n\n    $ mix sobelow -i Vuln.Redirect","title":"Sobelow.Vuln.Redirect","ref":"Sobelow.Vuln.Redirect.html"},{"type":"function","doc":"","title":"Sobelow.Vuln.Redirect.details/0","ref":"Sobelow.Vuln.Redirect.html#details/0"},{"type":"function","doc":"","title":"Sobelow.Vuln.Redirect.id/0","ref":"Sobelow.Vuln.Redirect.html#id/0"},{"type":"function","doc":"","title":"Sobelow.Vuln.Redirect.rule/0","ref":"Sobelow.Vuln.Redirect.html#rule/0"},{"type":"function","doc":"","title":"Sobelow.Vuln.Redirect.run/1","ref":"Sobelow.Vuln.Redirect.html#run/1"},{"type":"module","doc":"# Cross-Site Scripting\n\nCross-Site Scripting (XSS) vulnerabilities are a result\nof rendering untrusted input on a page without proper encoding.\nXSS may allow an attacker to perform actions on behalf of\nother users, steal session tokens, or access private data.\n\nRead more about XSS here:\nhttps://www.owasp.org/index.php/Cross-site_Scripting_(XSS)\n\nIf you wish to learn more about the specific vulnerabilities\nfound within the Cross-Site Scripting category, you may run the\nfollowing commands to find out more:\n\n          $ mix sobelow -d XSS.SendResp\n          $ mix sobelow -d XSS.ContentType\n          $ mix sobelow -d XSS.Raw\n          $ mix sobelow -d XSS.HTML\n\nXSS checks of all types can be ignored with the following command:\n\n    $ mix sobelow -i XSS","title":"Sobelow.XSS","ref":"Sobelow.XSS.html"},{"type":"function","doc":"","title":"Sobelow.XSS.details/0","ref":"Sobelow.XSS.html#details/0"},{"type":"function","doc":"","title":"Sobelow.XSS.finding_modules/0","ref":"Sobelow.XSS.html#finding_modules/0"},{"type":"function","doc":"","title":"Sobelow.XSS.get_template_vulns/1","ref":"Sobelow.XSS.html#get_template_vulns/1"},{"type":"function","doc":"","title":"Sobelow.XSS.get_vulns/4","ref":"Sobelow.XSS.html#get_vulns/4"},{"type":"function","doc":"","title":"Sobelow.XSS.rules/0","ref":"Sobelow.XSS.html#rules/0"},{"type":"module","doc":"# XSS in `put_resp_content_type`\n\nIf an attacker is able to set arbitrary content types for an\nHTTP response containing user input, the attacker is likely to\nbe able to leverage this for cross-site scripting (XSS).\n\nFor example, consider an endpoint that returns JSON with user\ninput:\n\n    {\"json\": \"user_input\"}\n\nIf an attacker can control the content type set in the HTTP\nresponse, they can set it to \"text/html\" and update the\nJSON to the following in order to cause XSS:\n\n    {\"json\": \" alert(document.domain) \"}\n\nContent Type checks can be ignored with the following command:\n\n    $ mix sobelow -i XSS.ContentType","title":"Sobelow.XSS.ContentType","ref":"Sobelow.XSS.ContentType.html"},{"type":"function","doc":"","title":"Sobelow.XSS.ContentType.details/0","ref":"Sobelow.XSS.ContentType.html#details/0"},{"type":"function","doc":"","title":"Sobelow.XSS.ContentType.id/0","ref":"Sobelow.XSS.ContentType.html#id/0"},{"type":"function","doc":"","title":"Sobelow.XSS.ContentType.parse_def/1","ref":"Sobelow.XSS.ContentType.html#parse_def/1"},{"type":"function","doc":"","title":"Sobelow.XSS.ContentType.rule/0","ref":"Sobelow.XSS.ContentType.html#rule/0"},{"type":"function","doc":"","title":"Sobelow.XSS.ContentType.run/2","ref":"Sobelow.XSS.ContentType.html#run/2"},{"type":"module","doc":"# XSS in `html`\n\nThis submodule looks for XSS vulnerabilities in `html`\ncalls from the Phoenix Controller.\n\nHTML checks can be ignored with the following command:\n\n    $ mix sobelow -i XSS.HTML","title":"Sobelow.XSS.HTML","ref":"Sobelow.XSS.HTML.html"},{"type":"function","doc":"","title":"Sobelow.XSS.HTML.details/0","ref":"Sobelow.XSS.HTML.html#details/0"},{"type":"function","doc":"","title":"Sobelow.XSS.HTML.id/0","ref":"Sobelow.XSS.HTML.html#id/0"},{"type":"function","doc":"","title":"Sobelow.XSS.HTML.parse_def/1","ref":"Sobelow.XSS.HTML.html#parse_def/1"},{"type":"function","doc":"","title":"Sobelow.XSS.HTML.rule/0","ref":"Sobelow.XSS.HTML.html#rule/0"},{"type":"function","doc":"","title":"Sobelow.XSS.HTML.run/2","ref":"Sobelow.XSS.HTML.html#run/2"},{"type":"module","doc":"# XSS in `raw`\n\nThis submodule checks for the use of `raw` in templates\nas this can lead to XSS vulnerabilities if taking user input.\n\nRaw checks can be ignored with the following command:\n\n    $ mix sobelow -i XSS.Raw","title":"Sobelow.XSS.Raw","ref":"Sobelow.XSS.Raw.html"},{"type":"function","doc":"","title":"Sobelow.XSS.Raw.details/0","ref":"Sobelow.XSS.Raw.html#details/0"},{"type":"function","doc":"","title":"Sobelow.XSS.Raw.id/0","ref":"Sobelow.XSS.Raw.html#id/0"},{"type":"function","doc":"","title":"Sobelow.XSS.Raw.parse_raw_def/1","ref":"Sobelow.XSS.Raw.html#parse_raw_def/1"},{"type":"function","doc":"","title":"Sobelow.XSS.Raw.parse_render_def/1","ref":"Sobelow.XSS.Raw.html#parse_render_def/1"},{"type":"function","doc":"","title":"Sobelow.XSS.Raw.rule/0","ref":"Sobelow.XSS.Raw.html#rule/0"},{"type":"function","doc":"","title":"Sobelow.XSS.Raw.run/4","ref":"Sobelow.XSS.Raw.html#run/4"},{"type":"module","doc":"# XSS in `send_resp`\n\nThis submodule looks for XSS vulnerabilities in the `body`\nargument of `Conn.send_resp`.\n\nSendResp checks can be ignored with the following command:\n\n    $ mix sobelow -i XSS.SendResp","title":"Sobelow.XSS.SendResp","ref":"Sobelow.XSS.SendResp.html"},{"type":"function","doc":"","title":"Sobelow.XSS.SendResp.details/0","ref":"Sobelow.XSS.SendResp.html#details/0"},{"type":"function","doc":"","title":"Sobelow.XSS.SendResp.id/0","ref":"Sobelow.XSS.SendResp.html#id/0"},{"type":"function","doc":"","title":"Sobelow.XSS.SendResp.parse_def/1","ref":"Sobelow.XSS.SendResp.html#parse_def/1"},{"type":"function","doc":"","title":"Sobelow.XSS.SendResp.rule/0","ref":"Sobelow.XSS.SendResp.html#rule/0"},{"type":"function","doc":"","title":"Sobelow.XSS.SendResp.run/2","ref":"Sobelow.XSS.SendResp.html#run/2"},{"type":"extras","doc":"# Sobelow\n\n[![Module Version](https://img.shields.io/hexpm/v/sobelow.svg)](https://hex.pm/packages/sobelow)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/sobelow/)\n[![Total Download](https://img.shields.io/hexpm/dt/sobelow.svg)](https://hex.pm/packages/sobelow)\n[![License](https://img.shields.io/hexpm/l/sobelow.svg)](https://hex.pm/packages/sobelow)\n[![Last Updated](https://img.shields.io/github/last-commit/nccgroup/sobelow.svg)](https://github.com/nccgroup/sobelow/commits/master)\n\nSobelow is a security-focused static analysis tool for Elixir & the\nPhoenix framework. For security researchers, it is a useful\ntool for getting a quick view of points-of-interest. For\nproject maintainers, it can be used to prevent the introduction\nof a number of common vulnerabilities.\n\nCurrently Sobelow detects some types of the following\nsecurity issues:\n\n* Insecure configuration\n* Known-vulnerable Dependencies\n* Cross-Site Scripting\n* SQL injection\n* Command injection\n* Code execution\n* Denial of Service\n* Directory traversal\n* Unsafe serialization\n\nPotential vulnerabilities are flagged in different colors\naccording to confidence in their insecurity. High confidence is\nred, medium confidence is yellow, and low confidence is green.\n\nA finding is typically marked \"low confidence\" if it looks\nlike a function could be used insecurely, but it cannot\nreliably be determined if the function accepts user-supplied\ninput. i.e. **If a finding is marked green, it *may* be\ncritically insecure, but it will require greater manual\nvalidation.**\n\n**Note:** This project is in constant development, and\nadditional vulnerabilities will be flagged as time goes on.\nIf you encounter a bug, or would like to request additional\nfeatures or security checks, please open an issue!","title":"Sobelow","ref":"readme.html"},{"type":"extras","doc":"- [Installation](#installation)\n  - [To Use](#to-use)\n- [Options](#options)\n- [Configuration Files](#configuration-files)\n- [False Positives](#false-positives)\n- [Modules](#modules)\n- [Umbrella Apps](#umbrella-apps)\n- [Updates](#updates)","title":"Table of Contents - Sobelow","ref":"readme.html#table-of-contents"},{"type":"extras","doc":"To use Sobelow, you can add it to your application's dependencies.\n\n```elixir\ndef deps do\n  [\n    {:sobelow, \"~> 0.13\", only: [:dev, :test], runtime: false}\n  ]\nend\n```\n\nYou can also install Sobelow globally by executing the following\nfrom the command line:\n\n    $ mix escript.install hex sobelow\n\nTo install from the master branch, rather than the latest release,\nthe following command can be used:\n\n    $ mix escript.install github nccgroup/sobelow","title":"Installation - Sobelow","ref":"readme.html#installation"},{"type":"extras","doc":"After installation, the simplest way to scan a Phoenix project is to run the\nfollowing from the project root:\n\n    $ mix sobelow","title":"To Use - Sobelow","ref":"readme.html#to-use"},{"type":"extras","doc":"**Note:** Any path arguments should be absolute paths, or\nrelative to the application root.\n\n  * `--root` or `-r` - Specify the application root directory.\n  Accepts a path argument, e.g. `../my_project`.\n\n  * `--verbose` or `-v` - Print code snippets and additional\n  finding details.\n\n  * `--ignore` or `-i` - Ignore given finding types. Accepts a\n  comma-separated list of module names, e.g. `XSS.Raw,Traversal`.\n\n  * `--ignore-files` - Ignore files. Accepts a comma-separated\n  list of file names, e.g. `config/prod.exs`.\n\n  * `--details` or `-d` - Get finding-type details. Accepts a\n  single module name, e.g. `Config.CSRF`.\n\n  * `--all-details` - Get details of all finding-types.\n\n  * `--private` - Skip update checks.\n\n  * `--router` - Specify router location. This only needs to be\n  used if the router location is non-standard. Accepts a path\n  argument, e.g. `my/strange/router.ex`.\n\n  * `--exit` - Return non-zero exit status at or above a confidence\n  threshold of `low`, `medium`, or `high`. Defaults to `false` which returns a zero exit status\n\n  * `--threshold` - Return findings at or above a confidence level\n  of `low` (default), `medium`, or `high`.\n\n  * `--format` or `-f` - Specify findings output format. Accepts a format,\n  e.g. `txt` or `json`.\n\n      Note that options such as `--verbose` will not work with the `json` format.\n      All `json` formatted findings contain a `type`, `file`, and `line` key.\n      Other keys may vary.\n\n  * `--quiet` - Return a single line indicating number of findings.\n  Otherwise, return no output if there are no findings.\n\n  * `--compact` - Minimal, single-line findings with output colorised\n    according to confidence.\n\n  * `--flycheck` - Minimal, single-line findings that are compatible\n    with flycheck-based tooling.\n\n  * `--save-config` - Generates a configuration file based on command\n  line options. See [Configuration Files](#configuration-files) for more\n  information.\n\n  * `--config` - Run Sobelow with configuration file. See [Configuration Files](#configuration-files)\n  for more information.\n\n  * `--mark-skip-all` - Mark all displayed findings as skippable.\n\n  * `--clear-skip` - Clear configuration created by `--mark-skip-all`.\n\n  * `--skip` - Ignore findings that have been marked for skipping. See [False Positives](#false-positives)\n  for more information.\n\n  * `--version` - Outputs the current version of Sobelow. This is useful for CI steps or integration with other tools like [Salus](https://github.com/coinbase/salus).","title":"Options - Sobelow","ref":"readme.html#options"},{"type":"extras","doc":"Sobelow allows users to save frequently used options in a\nconfiguration file. For example, if you find yourself constantly\nrunning:\n\n    $ mix sobelow -i XSS.Raw,Traversal --verbose --exit Low\n\nYou can use the `--save-config` flag to create your `.sobelow-conf`\nconfig file:\n\n    $ mix sobelow -i XSS.Raw,Traversal --verbose --exit Low --save-config\n\nThis command will create the `.sobelow-conf` file at the root\nof your application. You can edit this file directly to make\nchanges.\n\nYou can also run the command without any options:\n\n    $ mix sobelow --save-config\n\nwhen you first start out using this package - the generated configuration file\nwill be populated with the default values for each option. (This helps in\nquickly incorporating this package into a pre-existing codebase.)\n\nNow if you want to run Sobelow with the saved configuration,\nyou can run Sobelow with the `--config` flag.\n\n    $ mix sobelow --config","title":"Configuration Files - Sobelow","ref":"readme.html#configuration-files"},{"type":"extras","doc":"Sobelow favors over-reporting versus under-reporting. As such,\nyou may find a number of false positives in a typical scan.\nThese findings may be individually ignored by adding a\n`# sobelow_skip` comment, along with a list of modules, before\nthe function definition.\n\n```elixir\n# sobelow_skip [\"Traversal\"]\ndef vuln_func(...) do\n  ...\nend\n```\n\nWhen integrating Sobelow into a new project, there can be a\nlarge number of false positives. To mark all printed findings\nas false positives, run sobelow with the `--mark-skip-all` flag.\n\nOnce you have tagged the appropriate findings, run\nSobelow with the `--skip` flag.\n\n    $ mix sobelow --skip\n\nWhile `# sobelow_skip` comments can only mark function-level\nfindings (and so cannot be used to skip configuration issues),\nthe `--mark-skip-all` flag can be used to skip any finding\ntype.","title":"False Positives - Sobelow","ref":"readme.html#false-positives"},{"type":"extras","doc":"Findings categories are broken up into modules. These modules\ncan then be used to either ignore classes of findings (via the\n`ignore` and `skip` options) or to get vulnerability details (via the\n`details` option).\n\nThis list, and other helpful information, can be found on the\ncommand line:\n\n    $ mix help sobelow","title":"Modules - Sobelow","ref":"readme.html#modules"},{"type":"extras","doc":"In order to run Sobelow against all child apps within an umbrella app with a single command, you can add an alias for sobelow in your root `mix.exs` file:\n\n```elixir\ndefp aliases do\n  [\n    sobelow: [\"cmd mix sobelow\"]\n  ]\nend\n```\n\nIf you wish to use configuration files in an umbrella app, create a `.sobelow-conf` in each child application and use the `--config` flag.","title":"Umbrella Apps - Sobelow","ref":"readme.html#umbrella-apps"},{"type":"extras","doc":"When scanning a project, Sobelow will occasionally check for\nupdates, and will print an alert if a new version is available.\nSobelow keeps track of the last update-check by creating a\n`.sobelow` file in the root of the scanned project.\n\nIf this functionality is not desired, the `--private` flag can\nbe used with the scan.","title":"Updates - Sobelow","ref":"readme.html#updates"},{"type":"extras","doc":"# Changelog","title":"Changelog","ref":"changelog.html"},{"type":"extras","doc":"* Removed\n    * Support for minimum Elixir versions 1.7 - 1.11 (**POTENTIALLY BREAKING** - only applies if you relied on Elixir 1.7 through 1.11, 1.12+ is still supported)\n  * Enhancements\n    * Added support for multiple variations of `SQL.query()`\n    * Added support for `System.shell' command introduced in Elixir v1.12\n    * Ignore runtime config during `Config.HSTS`\n    * Updated developer dependencies (`ex_doc` & `credo`)\n  * Bug fixes\n    * Fixed `is_endpoint?` error in main\n    * Fixed findings normalization bug\n    * Fixed truncation error\n  * Misc\n    * GitHub Actions test matrix updated (hence the large drop in support for old Elixir versions)\n    * Addressed compiler warnings from Elixir v1.18.x\n    * Moved from `master` branch to `main`","title":"v0.14.0 - Changelog","ref":"changelog.html#v0-14-0"},{"type":"extras","doc":"* Removed\n    * Support for minimum Elixir versions 1.5 & 1.6 (**POTENTIALLY BREAKING** - only applies if you relied on Elixir 1.5 or 1.6, 1.7+ is still supported)\n  * Enhancements\n    * Fixed all `credo` warnings\n    * Implemented all `credo` \"Code Readability\" adjustments\n    * Took advantage of _some_ `credo` refactoring opportunities\n    * Added (sub)module documentation that was missing for some vulnerabilities and unified presentation of others\n  * Bug fixes\n    * Fixed `--details` / `-d` not displaying correct information\n    * Fixed incompatibility issue with Elixir 1.15\n  * Misc\n    * Added `mix credo --strict` to project\n    * Improvements to GitHub CI\n      * Hex Audit\n      * Compiler Warnings as Errors\n      * Checks Formatting\n    * Added helper `mix test.all` alias","title":"v0.13.0 - Changelog","ref":"changelog.html#v0-13-0"},{"type":"extras","doc":"* Bug fixes\n    * Removed `:castore` and introduced `:verify_none` to quiet warning and unblock escript usage, see [#133](https://github.com/nccgroup/sobelow/issues/133) for more context on why this is necessary","title":"v0.12.2 - Changelog","ref":"changelog.html#v0-12-2"},{"type":"extras","doc":"* Bug fixes\n    * Lowered required version of `:castore` to remove upgrade path issues\n    * Reconfigured `:verify_peer` to _actually_ use CAStore and remove warning","title":"v0.12.1 - Changelog","ref":"changelog.html#v0-12-1"},{"type":"extras","doc":"* Removed\n    * Support for minimum Elixir version 1.4 (**POTENTIALLY BREAKING** - only applies if you relied on Elixir 1.4, 1.5+ is still supported)\n  * Enhancements\n    * Adds support for HEEx to XSS.Raw\n    * Adds `--version` CLI flag\n    * README Improvements\n      * Umbrella App usage\n      * Clearer installation process\n      * Layout changes\n    * Updated dependencies\n  * Bug fixes\n    * Adds to_string() to exit_on\n    * Sets SSL opt verify_peer in version check\n    * Reworks `-v, --verbose` printing to not use the now deprecated `Macro.to_string/2`\n  * Misc\n    * Allows atom values for threshold in config file\n    * Uses SPDX ID for licenses in mixfile\n    * Fixed typo","title":"v0.12.0 - Changelog","ref":"changelog.html#v0-12-0"},{"type":"extras","doc":"* Enhancements\n    * Simplify `--flycheck` output to align with expected format","title":"v0.11.2 - Changelog","ref":"changelog.html#v0-11-2"},{"type":"extras","doc":"* Enhancements\n    * Sarif output with `--out` flag\n    * `--strict` flag, which throws compilation errors instead of suppressing them.","title":"v0.11.1 - Changelog","ref":"changelog.html#v0-11-1"},{"type":"extras","doc":"* Enhancements\n    * Sarif output for GitHub integration\n    * `--flycheck` flag, which reverses output of `--compact`\n  * Bug fixes\n    * Non-compiling files now return an empty syntax tree instead of\n    causing Sobelow errors.\n    * Command Injection finding description are properly formatted\n  * Misc\n    * If you use Sobelow as a standalone utility (i.e. not as part of\n    a Phoenix application), you now need to install as an escript with\n    `mix escript.install hex sobelow`.\n    * Custom JSON serialization replaced with Jason.","title":"v0.11.0 - Changelog","ref":"changelog.html#v0-11-0"},{"type":"extras","doc":"* Bug fixes\n    * Handle nil `config` case","title":"v0.10.6 - Changelog","ref":"changelog.html#v0-10-6"},{"type":"extras","doc":"* Misc\n    * Update code to clean up deprecation warnings","title":"v0.10.5 - Changelog","ref":"changelog.html#v0-10-5"},{"type":"extras","doc":"* Enhancements\n    * Sobelow is now smarter about cross-site websocket hijacking\n    * Update URL for CSRF description","title":"v0.10.4 - Changelog","ref":"changelog.html#v0-10-4"},{"type":"extras","doc":"* Bug fixes\n    * Fix directory structure issue in umbrella applications\n    * Handle function capture edge cases","title":"v0.10.3 - Changelog","ref":"changelog.html#v0-10-3"},{"type":"extras","doc":"* Bug fixes\n    * Fix a format error in JSON output encoding","title":"v0.10.2 - Changelog","ref":"changelog.html#v0-10-2"},{"type":"extras","doc":"* Bug fixes\n    * Sobelow will use \".sobelow-skips\" instead of \".sobelow\" in your root directory for `--mark-skip-all`","title":"v0.10.1 - Changelog","ref":"changelog.html#v0-10-1"},{"type":"extras","doc":"* Enhancements\n    * Sobelow now uses \"~/.sobelow/sobelow-vsn-check\" for update checks\n    * The \".sobelow\" file in your project root is for `--mark-skip-all` only","title":"v0.10.0 - Changelog","ref":"changelog.html#v0-10-0"},{"type":"extras","doc":"* Enhancements\n    * Improved checks for all aliased functions\n\n  * Bug Fixes\n    * JSON output for Raw findings is now properly normalized\n    * `send_download` correctly flags aliased function calls\n    * `send_download` now correctly flags piped functions","title":"v0.9.3 - Changelog","ref":"changelog.html#v0-9-3"},{"type":"extras","doc":"* Bug Fixes\n    * Fix error that resulted from redefining imported functions","title":"v0.9.2 - Changelog","ref":"changelog.html#v0-9-2"},{"type":"extras","doc":"* Bug Fixes\n    * Revert umbrella app recursion","title":"v0.9.1 - Changelog","ref":"changelog.html#v0-9-1"},{"type":"extras","doc":"* Enhancements\n    * Add `--mark-skip-all` and `--clear-skip` flags\n    * New CSRF via action reuse checks\n    * Sobelow can now be run in umbrella apps\n\n  * Bug Fixes\n    * Fix an error when printing some kinds of variables","title":"v0.9.0 - Changelog","ref":"changelog.html#v0-9-0"},{"type":"extras","doc":"* Enhancements\n    * Improve output consistency\n        * All JSON findings contain `type`, `file`, and `line` keys\n        * \"Line\" output now refers directly to the vulnerable line\n        * Default output headers have been normalized\n\n    **Note:** If you depend on the structure of the output, this\n    may be a breaking change. More information can be found at\n    [https://sobelow.io](https://sobelow.io).","title":"v0.8.0 - Changelog","ref":"changelog.html#v0-8-0"},{"type":"extras","doc":"* Enhancements\n    * Add `--threshold` flag\n    * Add module names to finding output\n\n  * Deprecations\n    * File/Path check has been deprecated\n\n  * Bug Fixes\n    * Fix inaccurate CSRF details","title":"v0.7.8 - Changelog","ref":"changelog.html#v0-7-8"},{"type":"extras","doc":"* Enhancements\n    * Add check for insecure websocket settings\n\n  * Bug Fixes\n    * Accept module attributes for application name","title":"v0.7.7 - Changelog","ref":"changelog.html#v0-7-7"},{"type":"extras","doc":"* Bug Fixes\n    * Fix issue that suppressed output options when config files were in use","title":"v0.7.6 - Changelog","ref":"changelog.html#v0-7-6"},{"type":"extras","doc":"* Misc\n    * Sobelow will now only halt when `--exit` flag is used","title":"v0.7.5 - Changelog","ref":"changelog.html#v0-7-5"},{"type":"extras","doc":"* Bug Fixes\n    * Log hardcoded secrets for txt output","title":"v0.7.4 - Changelog","ref":"changelog.html#v0-7-4"},{"type":"extras","doc":"* Misc\n    * Tweaks to `--out` flag.","title":"v0.7.3 - Changelog","ref":"changelog.html#v0-7-3"},{"type":"extras","doc":"* Enhancements\n    * Add router path to config findings\n    * Add `--out` flag for writing to file","title":"v0.7.2 - Changelog","ref":"changelog.html#v0-7-2"},{"type":"extras","doc":"* Enhancements\n    * Improved handling of JSON format\n    * Additional checks for File functions","title":"v0.7.1 - Changelog","ref":"changelog.html#v0-7-1"},{"type":"extras","doc":"* Enhancements\n    * Improved handling of vulnerabilities within templates.\n\n  * Bug Fixes\n    * Sobelow no longer incorrectly flags :binary `send_download` functions.","title":"v0.7.0 - Changelog","ref":"changelog.html#v0-7-0"},{"type":"extras","doc":"* Enhancements\n    * Improve template parsing and validation.\n    * Support multiple routers, and improve route discovery.\n\n  * Misc.\n    * Update language for missing directory.","title":"v0.6.9 - Changelog","ref":"changelog.html#v0-6-9"},{"type":"extras","doc":"* Bug Fixes\n    * Fix bug in the handling of certain piped functions.\n    * Revert not/in update that broke Elixir 1.4 compatibility.","title":"v0.6.8 - Changelog","ref":"changelog.html#v0-6-8"},{"type":"extras","doc":"* Enhancements\n    * Remove banner print from JSON format.\n\n  * Bug Fixes\n    * Fix error that occurred with certain function names in JSON format.","title":"v0.6.7 - Changelog","ref":"changelog.html#v0-6-7"},{"type":"extras","doc":"* Enhancements\n    * Add check for directory traversal via `send_download`\n    * Add check for missing Content-Security-Policy\n    * Check additional XSS vectors","title":"v0.6.6 - Changelog","ref":"changelog.html#v0-6-6"},{"type":"extras","doc":"* Bug Fixes\n    * Allow RCE module to be appropriately ignored.","title":"v0.6.5 - Changelog","ref":"changelog.html#v0-6-5"},{"type":"extras","doc":"* Enhancements\n    * Set timeout for version check.","title":"v0.6.4 - Changelog","ref":"changelog.html#v0-6-4"},{"type":"extras","doc":"* Enhancements\n    * Add RCE module to check for code execution via `Code` and `EEx`.\n\n  * Deprecations\n    * The `--with-code` flag has been changed to `--verbose`. The `--with-code`\n    flag will continue to work as expected until v1.0.0, but will print a\n    warning message.","title":"v0.6.3 - Changelog","ref":"changelog.html#v0-6-3"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}